//
// Convert binary file to header (include) file
//
//
#include <stdlib.h>
#include <stdio.h>

int main(int argc,char *argv[]){
    unsigned int filesize,count;
    unsigned char c;
    FILE *in,*out;
    if((in=fopen(argv[1],"rb"))==NULL){
            printf("could not open infile !\n");
            exit(1);
    }
    if((out=fopen(argv[2],"wb"))==NULL){
            printf("could not open outfile !\n");
            exit(1);
    }
    // bepaal lengte van infile
    if(fseek(in,0,SEEK_END)!=0){
            printf("seek error\n");
            exit(1);
    }
    filesize=ftell(in);
    printf("filesize: %d",filesize);
    fseek(in,0,SEEK_SET);
    // give header
    fprintf(out,"char %s[]={",argv[3]);

    for(count=0;count<filesize;count++){
           c=fgetc(in);
           fprintf(out,"0x%2.2x, ",c);
           // every 20 bytes, wrap line
           if(count%20==0){
                fprintf(out,"\n     ");
           }
    }
    fprintf(out,"0};");
    fclose(in);
    fclose(out);
}
